import java.awt.Point;
import java.awt.Rectangle;
import java.util.Random;


public class SquareThread implements Runnable {

	Square square;
	Drawing drawing;
	Thread thread;
	int waitTime;
	
	public SquareThread(Drawing d, Square s, int waitTime){
		this.drawing = d;
		this.square = s;
		this.waitTime = waitTime;
	}
	
	public void init(){
		System.out.println("Start square");
		thread = new Thread(this);
		thread.start();
	}
	
	public void run(){

		Random r = new Random();
		while(true)
		{	

			Rectangle bounds =  drawing.getBounds();
			
			Point top, bottom;
			
			top = new Point(0, bounds.y);
			bottom = new Point(0, bounds.y + bounds.height - square.size);
			System.out.println(top);
			System.out.println(bottom);
			

			if(this.square.touchLine(top)){
				System.out.println("Top Reached");
				square.vDirection = Shape.DOWN;
				square.hDirection = r.nextInt(2)-1;
			}
			else if(this.square.touchLine(bottom)){
				System.out.println("Bottom Reached");
				square.vDirection = Shape.UP;
				square.hDirection = r.nextInt(2)+1;
			}
			
			
			square.move();
			
			drawing.repaint();
			try{
				Thread.sleep(waitTime);
			}
			catch(InterruptedException e) {}
		}
		
	}

}
