import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;


/**
 * Classe abstraite de type forme dessinable.
 */
public abstract class Shape {
	
	static int LEFT = 1;
	static int RIGHT = 2;
	static int UP = 3;
	static int DOWN = 4;
	
	int hDirection = RIGHT;
	int vDirection = UP;

	protected Point origin;
	protected Color color;
	

	
	
	//public void addShapeLocationListener( ShapeLocationListener(drawing))
	
	
	public void setOrigin(Point p)
	{
		origin = p;
	}
	
	public void move()
	{
		if(hDirection == LEFT)
		{
			origin.x = origin.x - 1;
		}
		else if(hDirection == RIGHT)
		{
			origin.x = origin.x + 1;
		}
		
		if(vDirection == UP)
		{
			origin.y = origin.y - 1;
		}
		else if(vDirection == DOWN)
		{
			origin.y = origin.y + 1;
		}
	}
	
	/**
	 * dessine la forme sur un Graphics
	 */
	public abstract void paint(Graphics g);
	
	/**
	 * renvoie true si la forme occupe sur le point donnŽ
	 */
	public abstract boolean isOn(Point p);
}
